<?php

class LavoriController extends Controller
{

  const GRAFICA = 1;
  const MONTAGGIO = 2;
  const STAMPA = 3;
  const CONFEZIONE = 4;
  
  
  
  public $previd;
  

	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			'postOnly + delete', // we only allow deletion via POST request
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow', // allow admin user to perform 'admin' and 'delete' actions
				'actions'=>array('admin','delete','index','view','create','update','updateAjax','createfromordini','updatesconto','loadjsonmodel','loaddettagliordini','indexgrafico','indexmontaggio','indexstampa','indexconfezione','changestatusinizia','changestatussospendi','changestatusfine','setStatusFinito','changestatusiniziaall','changestatussospendiall','changestatusfineall','updatelavoropopup','indexdescrizione','printetichettapdf','updatedescrizione'),
				//'expression'=>'Yii::app()->user->getIsSuperAdmin()',
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model=new Lavori;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Lavori']))
		{
			$model->attributes=$_POST['Lavori'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->idlavoro));
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}
  
  
  
  	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreatefromordini()
	{
		$model=new Lavori;
    
		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Articoli']))
		{
          
      $lastId = Yii::app()->db->createCommand('SELECT id FROM lavori ORDER BY id DESC LIMIT 1')->queryScalar();
      $lastId++;
      if(isset($_POST['Articoli']['reparto'])) {
      
          if($_POST['Articoli']['reparto'] == self::GRAFICA) {
              $_POST['Articoli']['grafica'] = 1;
          }
          
          if($_POST['Articoli']['reparto'] == self::MONTAGGIO) {
              $_POST['Articoli']['montaggio'] = 1;
          }
          
          if($_POST['Articoli']['reparto'] == self::STAMPA) {
              $_POST['Articoli']['stampa'] = 1;
          }
          
          if($_POST['Articoli']['reparto'] == self::CONFEZIONE) {
              $_POST['Articoli']['confezione'] = 1;
          }

      }
      
	  $_POST['Articoli']['prezzounitario'] = str_replace(',','.',$_POST['Articoli']['prezzounitario']);
      $_POST['Articoli']['id'] = $lastId;  
      $_POST['Articoli']['idlavoro'] = $lastId;

			$model->attributes=$_POST['Articoli'];
			if($model->save())
				echo 'ok';
		}
	}
  
  
  

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Lavori']))
		{
			$model->attributes=$_POST['Lavori'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->idlavoro));
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}
	
	
	
	
	public function actionUpdateAjax($id)
	{
		$model=$this->loadModel($id);
		
		$_POST['Lavori']['confinvio'] = $this->data_it_to_eng($_POST['Lavori']['confinvio']);
		$_POST['Lavori']['confrientro'] = $this->data_it_to_eng($_POST['Lavori']['confrientro']);
		$_POST['Lavori']['grafinvio'] = $this->data_it_to_eng($_POST['Lavori']['grafinvio']);
		$_POST['Lavori']['grafrientro'] = $this->data_it_to_eng($_POST['Lavori']['grafrientro']);
		$_POST['Lavori']['staminvio'] = $this->data_it_to_eng($_POST['Lavori']['staminvio']);
		$_POST['Lavori']['stamrientro'] = $this->data_it_to_eng($_POST['Lavori']['stamrientro']);

		if(isset($_POST['Lavori']))
		{
			$model->attributes=$_POST['Lavori'];
			if($model->save()) { echo 'OK'; }
		
		}

		
	}
  
  
  
  
  public function actionUpdatesconto($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);
    
    
    
    

		if(isset($_POST['Lavori']))
		{
       if(isset($_POST['Lavori']['reparto'])) {
       
                $reparto= $_POST['Lavori']['reparto'];
                
                if($reparto == 'Grafica') {
                  $_POST['Lavori']['grafica'] = 1;
                  $_POST['Lavori']['montaggio'] = 0;
                  $_POST['Lavori']['stampa'] = 0;
                  $_POST['Lavori']['confezione'] = 0;
                }
                
                if($reparto == 'Montaggio') {
                  $_POST['Lavori']['grafica'] = 0;
                  $_POST['Lavori']['montaggio'] = 1;
                  $_POST['Lavori']['stampa'] = 0;
                  $_POST['Lavori']['confezione'] = 0;
                }
                
                if($reparto == 'Stampa') {
                  $_POST['Lavori']['grafica'] = 0;
                  $_POST['Lavori']['montaggio'] = 0;
                  $_POST['Lavori']['stampa'] = 1;
                  $_POST['Lavori']['confezione'] = 0;
                }
                
                if($reparto == 'Confezione') {
                  $_POST['Lavori']['grafica'] = 0;
                  $_POST['Lavori']['montaggio'] = 0;
                  $_POST['Lavori']['stampa'] = 0;
                  $_POST['Lavori']['confezione'] = 1;
                }
                
      }
      
			$model->attributes=$_POST['Lavori'];
			if($model->save()) {
				//print_r($model);
			} else {
				print_r($model->getErrors());
			}
		}

	}
	
	
	
	
	
	public function actionUpdatedescrizione($id)
	{
		$connection=Yii::app()->db;
        $sql='update lavori set descrizione =:descrizione where idlavoro=:id';
        $command=$connection->createCommand($sql);
        $command->bindParam(":id",$id,PDO::PARAM_STR);
        $command->bindParam(":descrizione",$_POST['Lavori']['descrizione'],PDO::PARAM_STR);
        $command->execute();
	}
	
  
  
  

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Lavori');
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}
  
  
 
	public function actionIndexgrafico()
	{
    $criteria=new CDbCriteria(array(
                                'condition'=>'t.grafica="1" AND relordine.stato <> "Attesa" AND relordine.stato <> "Consegnato" AND relordine.dapreventivare != "1" AND relordine.archivio != "1"',     /*AND YEAR(relordine.datainserimento) = YEAR(CURDATE()) */
                                'with'=>'relordine',
                                'together'=>true,
    ));
    
    
	$criteria->order = 'relordine.dataconsegna desc';
    /* Filtri */
    if(isset($_GET['Lavori']['tipologialavoro'])) {
        $criteria->compare('tipologialavoro',$_GET['Lavori']['tipologialavoro'],true);
    }
    
    
    if(isset($_GET['Lavori']['grafgrafico'])) {
        $criteria->compare('grafgrafico',$_GET['Lavori']['grafgrafico'],true);
    }
    
    
    if(isset($_GET['Lavori']['grafstato'])) {
        $criteria->compare('grafstato',$_GET['Lavori']['grafstato'],true);
    }
    
    
    if(isset($_GET['Lavori']['grafdove'])) {
        $criteria->compare('grafdove',$_GET['Lavori']['grafdove'],true);
    }

    
    if(isset($_GET['Lavori']['nosospesi']) && $_GET['Lavori']['nosospesi'] == '1') {
         $criteria->addCondition("t.stato!='Sospeso'");
    }
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'numordine') {
		$criteria->order = 'relordine.id desc';
	}
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'datains') {
		$criteria->order = 'relordine.datainserimento desc';
	}
	
    
    /* Fine Filtri */
    
    
    
    
		$dataProvider=new CActiveDataProvider('Lavori',array(
        'criteria'=>$criteria,
        'pagination'=>false,
    ));
    
		$this->render('indexgrafico',array(
			'dataProvider'=>$dataProvider,
      'settore'=>'Grafico',
		));
	}
  
  
  
  
  public function actionIndexdescrizione()
	{
    $criteria=new CDbCriteria(array(
        'condition'=>'1 = 1',
/* t.grafica="1" AND relordine.stato <> "Attesa" AND relordine.archivio != "1" */		
        'with'=>'relordine',
        'together'=>true,
        'order'=>'relordine.dataconsegna desc',
		));

    /* Filtri */
    if(isset($_GET['Lavori']['descrizione'])) {
		//$criteria->addSearchCondition('descrizione', $_GET['Lavori']['descrizione'], true, 'AND', 'LIKE');
		 $criteria->compare('descrizione',$_GET['Lavori']['descrizione'],true);
		} 
	else {
		$criteria->addCondition('t.id=0');
	    }
	
	$dataProvider=new CActiveDataProvider('Lavori',array(
        'criteria'=>$criteria,
        'pagination'=>false,
		));	  
	  
	$this->render('indexdescrizione',array(
		'dataProvider'=>$dataProvider,
		));	  
	  
	}
  
  
  
  
  public function actionIndexmontaggio()
	{

    $criteria=new CDbCriteria(array(
                                'condition'=>'t.montaggio="1" AND relordine.stato <> "Attesa" AND relordine.stato <> "Consegnato" AND relordine.dapreventivare != "1" AND relordine.archivio != "1"',     /*AND YEAR(relordine.datainserimento) = YEAR(CURDATE()) */
                                'with'=>'relordine',
                                'together'=>true,
    ));
    
    $criteria->order = 'relordine.dataconsegna desc';
    /* Filtri */
    if(isset($_GET['Lavori']['tipologialavoro'])) {
        $criteria->compare('tipologialavoro',$_GET['Lavori']['tipologialavoro'],true);
    }
    
    if(isset($_GET['Lavori']['nosospesi']) && $_GET['Lavori']['nosospesi'] == '1') {
         $criteria->addCondition("t.stato!='Sospeso'");
    }
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'numordine') {
		$criteria->order = 'relordine.id desc';
	}
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'datains') {
		$criteria->order = 'relordine.datainserimento desc';
	}
    
    /* Fine Filtri */
    
    
    
		$dataProvider=new CActiveDataProvider('Lavori',array(
        'criteria'=>$criteria,
        'pagination'=>false,
    ));
    
		$this->render('indexmontaggio',array(
			'dataProvider'=>$dataProvider,
      'settore'=>'Montaggio',
		));
	}
  
  
  
  public function actionIndexstampa()
	{
    
    $criteria=new CDbCriteria(array(
                                'condition'=>'t.stampa="1" AND relordine.stato <> "Attesa" AND relordine.stato <> "Consegnato" AND relordine.dapreventivare != "1" AND relordine.archivio != "1"',     /*AND YEAR(relordine.datainserimento) = YEAR(CURDATE()) */
                                'with'=>'relordine',
                                'together'=>true,
    ));
    
    $criteria->order = 'relordine.dataconsegna desc';
     /* Filtri */
    if(isset($_GET['Lavori']['tipologialavoro'])) {
        $criteria->compare('tipologialavoro',$_GET['Lavori']['tipologialavoro'],true);
    }
    
    
    if(isset($_GET['Lavori']['stamdove'])) {
        $criteria->compare('stamdove',$_GET['Lavori']['stamdove'],true);
    }
    
    
    if(isset($_GET['Lavori']['stamstato'])) {
        $criteria->compare('stamstato',$_GET['Lavori']['stamstato'],true);
    }
    
    
    if(isset($_GET['Lavori']['stammacchina'])) {
        $criteria->compare('stammacchina',$_GET['Lavori']['stammacchina'],true);
    }
    
    if(isset($_GET['Lavori']['nosospesi']) && $_GET['Lavori']['nosospesi'] == '1') {
         $criteria->addCondition("t.stato!='Sospeso'");
    }
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'numordine') {
		$criteria->order = 'relordine.id desc';
	}
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'datains') {
		$criteria->order = 'relordine.datainserimento desc';
	}
   
    
    /* Fine Filtri */
    
		$dataProvider=new CActiveDataProvider('Lavori',array(
        'criteria'=>$criteria,
        'pagination'=>false,
    ));
    
		$this->render('indexstampa',array(
			'dataProvider'=>$dataProvider,
      'settore'=>'Stampa',
		));
	}
  
  
  
  
  
  public function actionIndexconfezione()
	{
    
    $criteria=new CDbCriteria(array(
                                'condition'=>'t.confezione="1" AND relordine.stato <> "Attesa" AND relordine.stato <> "Consegnato" AND relordine.dapreventivare != "1" AND relordine.archivio != "1"',     /*AND YEAR(relordine.datainserimento) = YEAR(CURDATE()) */
                                'with'=>'relordine',
                                'together'=>true,
                                'order'=>'relordine.dataconsegna desc',

    ));
    
    $criteria->order = 'relordine.dataconsegna desc';
      /* Filtri */
    if(isset($_GET['Lavori']['tipologialavoro'])) {
        $criteria->compare('tipologialavoro',$_GET['Lavori']['tipologialavoro'],true);
    }
    
    
    if(isset($_GET['Lavori']['confdove'])) {
        $criteria->compare('confdove',$_GET['Lavori']['confdove'],true);
    }
    
    
    if(isset($_GET['Lavori']['confstato'])) {
        $criteria->compare('confstato',$_GET['Lavori']['confstato'],true);
    }
    
    
    if(isset($_GET['Lavori']['nosospesi']) && $_GET['Lavori']['nosospesi'] == '1') {
         $criteria->addCondition("t.stato!='Sospeso'");
    }
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'numordine') {
		$criteria->order = 'relordine.id desc';
	}
	
	if(isset($_GET['Lavori']['searchorderby']) && $_GET['Lavori']['searchorderby'] == 'datains') {
		$criteria->order = 'relordine.datainserimento desc';
	}
    
    /* Fine Filtri */
    
    
		$dataProvider=new CActiveDataProvider('Lavori',array(
        'criteria'=>$criteria,
        'pagination'=>false,
    ));
    
		$this->render('indexconfezione',array(
			'dataProvider'=>$dataProvider,
      'settore'=>'Confezione',
		));
	}
  
  
  
  
  public function actionChangestatusinizia($id) {
  
        $model=$this->loadModel($id);
        $model->stato='In lavorazione';
        if($model->save()) { 
            echo 'Stato impostato';    
        } else {
            echo 'Errore';
        }
        
  }
  
  
  
  public function actionChangestatussospendi($id) {
  
       $model=$this->loadModel($id);
       $model->stato='Sospeso';
       if($model->save()) { 
            echo 'Stato impostato';    
       } else {
            echo 'Errore';
       }
       
  }
  
  
  public function actionChangestatusfine($id) {
  
      $model=$this->loadModel($id);
      
      if($model->grafica == '1') {
          $model->grafica = '0';
          $model->montaggio = '1';
          $model->stato='Attesa';
      } else if($model->montaggio == '1') {
          $model->montaggio = '0';
          $model->stampa = '1';
          $model->stato='Attesa';
      } else if($model->stampa == '1') {
          $model->stampa = '0';
          $model->confezione = '1';
          $model->stato='Attesa';
      } else if($model->confezione == '1') {
          $model->stato='Pronto';
      }
      
      
      
      
      if($model->save()) { 
            echo 'Stato impostato';    
      } else {
            echo 'Errore';
      } 
      
      
  
  }
  
  
  
  public function actionSetStatusFinito($id) {
 
      $model=$this->loadModel($id);
      $model->grafica = '0';
	  $model->montaggio = '0';
	  $model->stampa = '0';
	  $model->confezione = '0';
	  $model->stato='Pronto';
      
      if($model->save()) { 

			$criteria = new CDbCriteria();
			$criteria->condition = 'idordine=:idordine';
			$criteria->params = array(':idordine'=>$model->idordine);
			$alllavori = Lavori::model()->findAll($criteria);	
			if($alllavori) {
			$all = true;
			foreach($alllavori as $single) {
				
				if($single->stato != 'Pronto') {
					
					$all = false;
					
				}
				
			}
			
			
			if($all) {
				
				$modelordine = Ordini::model()->findByPk($model->idordine);
				$modelordine->stato = 'Pronto';
				$modelordine->save();
				echo 'alldone';
				
			}
			
			
			}
					
					
      } else {
            echo 'Errore';
      } 
  
  }
  
  
    public function actionChangestatusiniziaall($idordine) {
  
        //$model=Lavori::model()->findByPk($id);
        $criteria = new CDbCriteria();
        $criteria->condition = 'idordine=:idordine';
        $criteria->params = array(':idordine'=>$idordine);
        $model = Lavori::model()->findAll($criteria);
        //$model=$this->loadModel($id);
        if($model) {
          foreach($model as $singlelavoro) {
              
              $singlelavoro->stato='In lavorazione';
              if($singlelavoro->save()) { 
                  echo 'Stato impostato';    
              } else {
                  echo 'Errore';
              }
          }
        }
        
  }
  
  
  
  public function actionChangestatussospendiall($idordine) {
  
       //$model=$this->loadModel($id);
       
       $criteria = new CDbCriteria();
       $criteria->condition = 'idordine=:idordine';
       $criteria->params = array(':idordine'=>$idordine);
       $model = Lavori::model()->findAll($criteria);
       
       if($model) {
         foreach($model as $singlelavoro) {
           $singlelavoro->stato='Sospeso';
           if($singlelavoro->save()) { 
                echo 'Stato impostato';    
           } else {
                echo 'Errore';
           }
         }
       }
       
  }
  
  
  public function actionChangestatusfineall($idordine) {
  
      //$model=$this->loadModel($id);
       $criteria = new CDbCriteria();
       $criteria->condition = 'idordine=:idordine';
       $criteria->params = array(':idordine'=>$idordine);
       $model = Lavori::model()->findAll($criteria);
  
       if($model) {
         foreach($model as $singlelavoro) {
         
            //print_r($singlelavoro);
            if(isset($singlelavoro->grafica) && $singlelavoro->grafica == '1') {
                $singlelavoro->grafica = '0';
                $singlelavoro->montaggio = '1';
                $singlelavoro->stato='Attesa';
            } else if(isset($singlelavoro->montaggio) && $singlelavoro->montaggio == '1') {
                $singlelavoro->montaggio = '0';
                $singlelavoro->stampa = '1';
                $singlelavoro->stato='Attesa';
            } else if(isset($singlelavoro->stampa) && $singlelavoro->stampa == '1') {
                $singlelavoro->stampa = '0';
                $singlelavoro->confezione = '1';
                $singlelavoro->stato='Attesa';
            } else if(isset($singlelavoro->confezione) && $singlelavoro->confezione == '1') {
                $singlelavoro->stato='Pronto';
            }
            
            
            if($singlelavoro->save()) { 
                  echo 'Stato impostato';    
            } else {
                  echo 'Errore';
            } 
        } 
      } 
      
      
  
  }
  
  
  
  
  
  
  

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Lavori('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Lavori']))
			$model->attributes=$_GET['Lavori'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}
  
  
  
  /**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionLoadjsonmodel($id)
	{
		echo CJSON::encode($this->loadModel($id));
	}
  
  
  public function actionLoaddettagliordini($id) {
      $model=$this->loadModel($id);
      $this->renderPartial('_formdettagliordine',array(
			'modellav_void'=>$model,
		));
  
  }
  
  
  public function actionUpdatelavoropopup($id) {
       $model=$this->loadModel($id);
       $this->renderPartial('_formdettagliolavoro',array(
			   'model'=>$model,
		   ));
  }
  
  
  
  public function actionPrintetichettapdf($id) { //Andrea
  
	$modelsinglelav=Lavori::model()->findByPk($id);  
	$model = Ordini::model()->findByPk($modelsinglelav->idordine);  
	if(empty($model->codcliente)) {
		$model->relcliente = new Clienti;
	}
	//print_r($model);
	$htm =$this->renderPartial('printordineetichette', array('model'=>$model,'modelsinglelav'=>$modelsinglelav), true);
	$footer = $this->renderPartial('footerstampaetichette', array('model'=>$model), true);
	
	$stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/stampaconsegna.css');
	
	$mPDF1 = Yii::app()->ePdf->mpdf('','A5-L');
	$mPDF1->SetHTMLFooter($footer);
	$mPDF1->WriteHTML($stylesheet, 1);
	$mPDF1->WriteHTML($htm,2);
	$mPDF1->Output();

  }
  
  

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Lavori the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Lavori::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Lavori $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='lavori-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
	
	
	private function data_it_to_eng($var){
		list($gg, $mm, $aaaa) = explode("-", $var);
		return $aaaa."-".$mm."-".$gg;
	}
}
