<?php

class OrdiniController extends Controller
{



	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';
	public $totalisum = 0;

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			/*'postOnly',*/ // we only allow deletion via POST request
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('scanandnotify'),
                'users' => array('*'),
            ),
			array('allow', // allow admin user to perform 'admin' and 'delete' actions
				'actions'=>array('admin','delete','deleteall','preventivare','consegne','changestatusfine','trovaordini','modificaordine','changestatuspreventivato','create','update','index','view','nuovoordine','updatenuovoordine','printordine','printordinepdf','printpdfpreventivo','printetichettapdf','ricercapercliente','daconfermare','clonaordine','ricercaperclientedaconf','fetchlavori','getLastLavori','loadlavorojson','exportordine','setStatoProntoAll','myordini','consegnati','pronti','inviapreventivo','allordini','clonaordinetest'),
				//'expression'=>'Yii::app()->user->getIsSuperAdmin()',
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model=new Ordini;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Ordini']))
		{
			
			$model->attributes=$_POST['Ordini'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->idordine));
		}
    

		$this->render('create',array(
			'model'=>$model,
		));
	}
  
 
 
	public function actionGetLastLavori() {
 
        if(isset($_POST['idcliente'])) {
        
        
            $criteria = new CDbCriteria();
            $criteria->condition = 'codcliente=:codcliente';
            $criteria->order = 'datainserimento desc';
            $criteria->params = array(':codcliente'=>$_POST['idcliente']);
            $allordini = Ordini::model()->findAll($criteria);
            
            $miohtml = '';
            $trovato = 0;
            $miohtml = '<div class="grid-view"><table id="tabLavori" cellpadding="2" cellspacing="1" border="0" width="100%" class="items"><tr><th><b>Data</b></th><th><b>Cod</b></th><th><b>Lavoro</b></th><th><b>Qt&agrave;</b></th><th><b>Prezzo</b></th><th><b>Sconto</b></th><th><b>Tot.</b></th><th>&nbsp;</th></tr>';
            $cont = 0;
            $class = 'odd';
			
			$idsordini = array();
			
            foreach($allordini as $singleordine) {
                //$this->actionfetchlavoriForAutocomplete($singleordine->idordine);
                if($singleordine->archivio != '1' && $singleordine->dapreventivare != '1') {
                    //$lavori = Lavori::model()->findAll('idordine =:id',array(':id'=> ));
					
					$idsordini[] = $singleordine->idordine;
					
					
					
					
                    /*foreach($lavori as $lavoro) {
                      if($cont % 2 == 0) { $class = 'odd'; } else { $class = 'even'; }
    		            	$trovato = 1;
    		              $miohtml = $miohtml . "<tr class='".$class."'><td>".date('d/m/Y',strtotime($singleordine->datainserimento))."</td><td>".$lavoro->cod."</td><td>".substr($lavoro->descrizione,0,80)."</td><td style='text-align:right;'>$lavoro->quantita</td><td>$lavoro->prezzounitario</td><td>".$lavoro->sconto."</td><td>".round($lavoro->quantita*$lavoro->prezzounitario - ($lavoro->quantita*$lavoro->prezzounitario*$lavoro->sconto/100),2)."</td><td width='30' align='center'></td></tr>";
                      $cont++;
    		            } */
                }
            }
            
			
			
					$modellav = new Lavori;
					if(isset($_GET['Lavori'])) {
						$modellav->attributes=$_GET['Lavori'];
					}
					$modellav->idsordini = $idsordini;
					
					$lavoriDp = $modellav->searchLavoripopup();

					
					
					$ccc = $this->widget('zii.widgets.grid.CGridView', array(
						'id'=>'lavori-grid',
						'dataProvider'=>$lavoriDp,
						'filter'=>$modellav,
						'summaryText'=>'<b>Lavori trovati: <span style="color:red;">{count}</span></b>',
						'htmlOptions'=>array('style'=>'cursor: pointer;'),
						'columns'=>array(
							'cod',
							'descrizione',
							'quantita',
							'unita',
							'prezzounitario',
							array('name'=>'idordine','header'=>'','type'=>'raw','htmlOptions'=>array('style'=>'width:20px; text-align:center;'),'value'=>function($data) { return "<a href='#' class='addorder' id='".$data->idlavoro."'><i class='icon-share'></i></a>"; })
						),
						
						'template'=>"{summary}{pager}\n{items}\n{pager}", 
						
					)
				); 
			
			
			
			
			
			
			
            //$miohtml = $miohtml . '</table></div>';
            /*if ($trovato == 1) {
			       echo $miohtml;
		        } else {
			       echo '';
		        }*/
            

        } else {
            echo 'error: id not set';
        }
        
 
 
 }
 
 
 
 
 
 
  
  
  
 	public function actionNuovoordine() {
		$firstRecord = new Ordini();
		$criteria=new CDbCriteria;
		$criteria->select='max(idordine) as maxColumn';
		$row = $firstRecord->model()->find($criteria);
		$nuovoid = $row['maxColumn'] + 1;
		$firstRecord->relcliente = new Clienti();
		$firstRecord->datainserimento = date("Y-m-d H:i:s"); //Andrea    
		$firstRecord->dataconsegna = date("Y-m-d H:i:s"); //Mose  
		$firstRecord->id = $nuovoid;
		$firstRecord->idordine = $nuovoid;
		$firstRecord->utente_id = Yii::app()->user->id;
		
		if($firstRecord->save()) {
		  $firstRecord->stato = 'Draft';
		  if($firstRecord->save()) {
			$this->redirect(array('updatenuovoordine','id'=>$firstRecord->idordine));
		  }   
		}
	}


  public function actionModificaordine() {
	$model=Ordini::model()->findByPk($id);

	if(isset($_GET['Ordini'])) {
		$model->attributes=$_GET['Ordini'];
		//if($model->save()) { 
			$this->redirect(array('admin')); 
		//}
	} 
     
  }

	
	public function actionScanandnotify() {
	  
		$dp = Ordini::model()->with('relnotifiche')->findAll(array('condition'=>'relnotifiche.status <> "Sent" AND t.datainserimento > "2016-01-01 00:00:01"'));
		
		foreach($dp as $single) {
			
			
				$model=Ordini::model()->findByPk($single->id);  
				if(empty($model->codcliente)) {
					$model->relcliente = new Clienti;
				}

				Yii::import('ext.yii-mail.YiiMailMessage');
				$message = new YiiMailMessage;
				$message->setBody('Prova', 'text/html');
				$message->subject = 'Prova';
				$message->addTo('mozer_3@hotmail.com');
				$message->setFrom(array('info@sigem.it' => 'Produzione Sigem'));
				Yii::app()->mail->transportOptions= array('host'=>'authsmtp.sigem.it','timeout'=>10,'port'=>'25','username' => 'smtp@sigem.it','password' => '21sm12@Sm15'); //'encryption'=>$encryption,
	  
				if(Yii::app()->mail->send($message)) {
			 	  $flagsent = true;
				} else {
				  //echo '<label style="color:#FFc63f;width:300px;"><b>FALLITO</b></label> - '.$azienda->nomazienda.' &lt;'.$azienda->mail.'&gt;</label><br/>';
				} 			
		}
	  
		echo count($dp);
	 
	}
	
	
	public function actionInviapreventivo() {
		
		if(isset($_POST['modalid']) && isset($_POST['modalemail'])) {
			$model=Ordini::model()->findByPk($_POST['modalid']); 
			$modelagente=Agenti::model()->findByPk($model->agente);
			
			Yii::import('ext.yii-mail.YiiMailMessage');
			$message = new YiiMailMessage;
			
			$txtemail = 'Da GRAFICHE SIGEM srl<br /><br />';
			$txtemail .= 'Spettabile '.$model->relcliente->nomeditta.',<br />';
			$txtemail .= 'Come da accordi siamo a inviarvi preventivo Rif.'.$model->idordine.' (Vedi file PDF allegato).<br /><br />';
			$txtemail .= 'Vi chiediamo cortesemente di controllare la correttezza<br />';
			$txtemail .= 'dei dati di fatturazione e di comunicarci eventuali errori<br /><br />';
			$txtemail .= 'Cordiali saluti<br /><br />';
			if(isset($modelagente->nome) && isset($modelagente->cognome)) {
				$txtemail .= $modelagente->nome.' '.$modelagente->cognome.'<br /><br />';
			}
			$txtemail .= 'Grafiche Sigem srl<br />';
			$txtemail .= 'Via Emilia Est 1741<br />';
			$txtemail .= '41122 Modena<br />';
			$txtemail .= 'tel. 059 280 311 (3 Linee RA)<br />';
			$txtemail .= '<a href="mailto:ordini@sigem.it">ordini@sigem.it</a><br />';
			
			
			$message->setBody($txtemail, 'text/html');
			$message->subject = 'Produzione Sigem - Preventivo - Rif. '.$model->idordine;
			$message->addTo($_POST['modalemail']);
			$mittente = 'ordini@sigem.it';
			if(Yii::app()->user->getUser()->mail) { $mittente = Yii::app()->user->getUser()->mail; }
			
			$message->setFrom(array($mittente => Yii::app()->user->getUser()->nome.' '.Yii::app()->user->getUser()->cognome.' - Grafiche Sigem'));
			Yii::app()->mail->transportOptions= array('host'=>'authsmtp.sigem.it','timeout'=>10,'port'=>'25','username' => 'smtp@sigem.it','password' => '21sm12@Sm15'); //'encryption'=>$encryption,
 
			if(empty($model->codcliente)) {
				$model->relcliente = new Clienti;
			}

			$htm =$this->renderPartial('printordinepreventivo', array('model'=>$model), true);
			$footer = $this->renderPartial('footerstampapreventivo', array('model'=>$model), true);
			$stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/stampaconsegna.css');
	
			$mPDF1 = Yii::app()->ePdf->mpdf('utf-8','A4', 0, '', 13, 13, 4, 4, 0, 0);
			$mPDF1->SetHTMLFooter($footer);
			$mPDF1->WriteHTML($stylesheet, 1);
			$mPDF1->WriteHTML($htm,2);
			
			
			
	
	
			//output it as string and use the new setStringMethod               
			//$message->addStringAttachment(,'preventivo.pdf');
			
			//$output = file_get_contents('http://192.168.0.160/produzionesigem/index.php?r=ordini/printpdfpreventivo&id='.$model->id);
			//$message->addPart($output, 'application/pdf');
			
			$attachment = Swift_Attachment::newInstance($mPDF1->Output('','S'), 'preventivo.pdf', 'application/pdf');
			$message->attach($attachment);
  
			if(Yii::app()->mail->send($message)) {
			  $flagsent = true;
			  $model->inviatopreventivo = '1';
			  $model->datainvio = date('Y-m-d H:i:s');
			  $model->save();
			  print 'inviato preventivo';
			  //print_r($model);
			} else {
			  //echo '<label style="color:#FFc63f;width:300px;"><b>FALLITO</b></label> - '.$azienda->nomazienda.' &lt;'.$azienda->mail.'&gt;</label><br/>';
			} 			
				
		}

		echo 'ok';
		
		
		
		
	}
  
  public function actionUpdatenuovoordine($id)
	{
	
	if ($id=='xx') {
		$model=Ordini::model()->findByPk($_GET['Ordini']['idordine']);
	} else {
		$model=Ordini::model()->findByPk($id);
	}

	if(!$model) { echo 'Ordine non esistente';  die; }
	
	if(isset($_POST['Ordini'])) {
		if($_POST['Ordini']['stato'] == 'Draft') {
			$_POST['Ordini']['stato'] = 'Inserito';
		}
		
		
		$_POST['Ordini']['dataconsegna'] = $this->data_it_to_eng($_POST['Ordini']['dataconsegna']);
		$_POST['Ordini']['datainserimento'] = $this->data_it_to_eng($_POST['Ordini']['datainserimento']);
		
		
	
		$model->attributes=$_POST['Ordini'];
		if($model->save()) { 
			//$this->redirect(array('admin')); 
			echo '<script>window.close();  window.opener.$.fn.yiiGridView.update("ordini-grid");</script>';
		}
	} 
    
    if(empty($model->codcliente)) {
    
        $model->relcliente = new Clienti;
    }


	$this->render('nuovoordine',array(
			'model'=>$model,
	));
	}
  
  
  
  public function actionPrintordine($id) {
  
    $model=Ordini::model()->findByPk($id);
   
       
    if(empty($model->codcliente)) {
		$model->relcliente = new Clienti;
    }
      

  
    $this->renderPartial('printordine',array(
			   'model'=>$model,
	));
  }
  
  

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Ordini']))
		{
			$model->attributes=$_POST['Ordini'];
			if($model->save()) {
				//$this->redirect(array('view','id'=>$model->idordine));
				$this->redirect(array('admin'));
			}
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();
		Lavori::model()->deleteAll("idordine = '".$id."'");
		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax'])) {
			echo '<script>window.close();  window.opener.$.fn.yiiGridView.update("ordini-grid");</script>';
		}
			//$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Ordini');
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Ordini('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Ordini']))
			$model->attributes=$_GET['Ordini'];

		$dataprov = $model->search();
		$this->render('indexordiniattivi',array(
			'model'=>$model,
			'dataProvider'=>$dataprov,			
		));
		
	}
	
	/* Filtra ordini per agente in sessione */
	public function actionMyordini() {
		 //$modelordine = $this->loadModel($id);
		 
		 $user = Utenti::model()->findByPk(Yii::app()->getUser()->id);
		
		 
		 $model=new Ordini();
		 $_GET['Ordini']['agente'] = $user->idagente; 
		 $model->attributes=$_GET['Ordini'];
		 //$model->anchearchiviati = 1;
		
		
		
		
		$dataprov = $model->searchMyOrdini();	
		$this->render('indexmyordini',array(
			'dataProvider'=>$dataprov,
			'model'=>$model,
		));		
		 
		 
		 
		 
	}

	
	/* Andrea - Filtro sulla base degli ordini da preventivare */
	public function actionPreventivare()
	{
		$model=new Ordini('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Ordini']))
			$model->attributes=$_GET['Ordini'];

		$dataprov = $model->searchPreventivare();
		$this->render('preventivare',array(
			'model'=>$model,
			'dataProvider'=>$dataprov,
		));
	}	
	
	
	
	/* Andrea - Filtro sulla base degli ordini in attesa di conferma */
	public function actionDaconfermare()
	{
		$model=new Ordini('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Ordini']))
			$model->attributes=$_GET['Ordini'];

		$dataprov = $model->searchDaconfermare();	
    

    
		$this->render('indextrovaordinidaconf',array(
			'model'=>$model,
      'dataProvider'=>$dataprov,
		));	
	}		
	
	/* Andrea 09/11/2014 - Filtro gli ordini sulla base dell'id cliente */
	public function actionRicercapercliente()
	{
		$model=new Ordini();
		$model->anchearchiviati = 1;
		
		if (isset($_GET['Ordini']['nomecli'])) {
			$model->nomecli = $_GET['Ordini']['nomecli'];
		}
		
		
		if(isset($_GET['Ordini']['nomeditta_search'])) {
			$model->nomeditta_search = $_GET['Ordini']['nomeditta_search'];
		}
		
		if(isset($_GET['Ordini']['idordine'])) {
			$model->idordine = $_GET['Ordini']['idordine'];
		}
		
		if(isset($_GET['Ordini']['nota'])) {
			$model->nota = $_GET['Ordini']['nota'];
		}
		
		if(isset($_GET['Ordini']['referente'])) {
			$model->referente = $_GET['Ordini']['referente'];
		}
		
		if(isset($_POST['Ordini']['datains'])) {
			$model->datains = $_POST['Ordini']['datains'];
		}
		
		$dataprov = $model->searchCliente();	
		$this->render('indextrovaordini',array(
			'dataProvider'=>$dataprov,
			'model'=>$model,
		));		
	}
	
	
	public function actionAllordini() {
		
		$model=new Ordini();
		$model->anchearchiviati = 1;
		
		if (isset($_GET['Ordini']['nomecli'])) {
			$model->nomecli = $_GET['Ordini']['nomecli'];
		}
		
		
		if(isset($_GET['Ordini']['nomeditta_search'])) {
			$model->nomeditta_search = $_GET['Ordini']['nomeditta_search'];
		}
		
		if(isset($_GET['Ordini']['idordine'])) {
			$model->idordine = $_GET['Ordini']['idordine'];
		}
		
		if(isset($_GET['Ordini']['nota'])) {
			$model->nota = $_GET['Ordini']['nota'];
		}
		
		if(isset($_GET['Ordini']['referente'])) {
			$model->referente = $_GET['Ordini']['referente'];
		}
		
		if(isset($_POST['Ordini']['datains'])) {
			$model->datains = $_POST['Ordini']['datains'];
		}
		
		$dataprov = $model->searchClienteallordini();	
		$this->render('indextrovaordini',array(
			'dataProvider'=>$dataprov,
			'model'=>$model,
		));		
	}
	
	
	
	/* Andrea 09/11/2014 - Filtro gli ordini sulla base dell'id cliente */
	public function actionRicercaperclientedaconf()
	{
		$model=new Ordini();
		
		if (isset($_GET['Ordini']['nomecli'])) {
			$model->nomecli = $_GET['Ordini']['nomecli'];
		}
		
		$dataprov = $model->searchClientedaconf();	
		$this->render('indextrovaordinidaconf',array(
			'dataProvider'=>$dataprov,
			'model'=>$model,
		));		

		
	}	
	
	
	
	/* Andrea - Filtro sulla base degli ordini da consegnare */
	public function actionConsegne() {
	
		$model=new Ordini();
		
		if (isset($_GET['Ordini']['ordinamento'])) {
			$model->ordinamento = $_GET['Ordini']['ordinamento'];
		}
		
		if (isset($_GET['Ordini']['tipologiaordine'])) {
			$model->tipologiaordine = $_GET['Ordini']['tipologiaordine'];
		} else {
			//	$model->tipologiaordine = ' ';
		}
		
		if (isset($_GET['Ordini']['recenti'])) {
			$model->recenti = $_GET['Ordini']['recenti'];
		} else {
			$model->recenti = '';
		}	
		
		
		if(isset($_GET['Ordini']['nomeditta_search'])) {
			$model->nomeditta_search = $_GET['Ordini']['nomeditta_search'];
		}
		
		if(isset($_GET['Ordini']['idordine'])) {
			$model->idordine = $_GET['Ordini']['idordine'];
		}
		
		if(isset($_GET['Ordini']['nota'])) {
			$model->nota = $_GET['Ordini']['nota'];
		}
		
		if(isset($_GET['Ordini']['referente'])) {
			$model->referente = $_GET['Ordini']['referente'];
		}

		$dataprov = $model->searchConsegne();
		$this->render('indexconsegne',array(
			'dataProvider'=>$dataprov,
			'model'=>$model,
		));
	
	}	
	
	
	public function actionPronti() {
		
		$model=new Ordini();
		
		if (isset($_GET['Ordini']['ordinamento'])) {
			$model->ordinamento = $_GET['Ordini']['ordinamento'];
		}
		
		if (isset($_GET['Ordini']['tipologiaordine'])) {
			$model->tipologiaordine = $_GET['Ordini']['tipologiaordine'];
		} else {
			//	$model->tipologiaordine = ' ';
		}
		
		if (isset($_GET['Ordini']['recenti'])) {
			$model->recenti = $_GET['Ordini']['recenti'];
		} else {
			$model->recenti = '';
		}	
		
		
		if(isset($_GET['Ordini']['nomeditta_search'])) {
			$model->nomeditta_search = $_GET['Ordini']['nomeditta_search'];
		}
		
		if(isset($_GET['Ordini']['idordine'])) {
			$model->idordine = $_GET['Ordini']['idordine'];
		}
		
		if(isset($_GET['Ordini']['nota'])) {
			$model->nota = $_GET['Ordini']['nota'];
		}
		
		if(isset($_GET['Ordini']['referente'])) {
			$model->referente = $_GET['Ordini']['referente'];
		}

		$this->render('indexpronti',array(
			'dataProvider'=>$model->searchConsegne(),
			'model'=>$model,
		));
		
		
	}
	
	
	
	
	public function actionConsegnati() {
		$model=new Ordini();
		$dp = $model->searchOrdiniconsegnati();	
		$this->render('indexordiniconsegnati',array(
			'dataProvider'=>$dp,
			'model'=>$model,
		));		
	}
	
	
	
	
	
	
  public function actionPrintordinepdf($id) { //Andrea
  
	$model=Ordini::model()->findByPk($id);  
	if(empty($model->codcliente)) {
		$model->relcliente = new Clienti;
	}

	$htm =$this->renderPartial('printordineconsegne', array('model'=>$model), true);
	$footer = $this->renderPartial('footerstampaconsegne', array('model'=>$model), true);
	$stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/stampaconsegna.css');
	
	$mPDF1 = Yii::app()->ePdf->mpdf('utf-8','A4', 0, '', 13, 13, 4, 4, 0, 0);
	$mPDF1->SetHTMLFooter($footer);
	$mPDF1->WriteHTML($stylesheet, 1);
	$mPDF1->WriteHTML($htm,2);

	/* Routine per mettere watermark a sx "Compilato da" */
	if($model->utente_id != 0) {
		$angle = 90;
		$szfont = 8;
		$testo = 'Compilato da '.Utenti::renderNameById($model->utente_id);
		$strlen = strlen($testo);
		$offset = -16;
		$mPDF1->SetFont( 'sans-serif', "", $szfont-0.1, true, true);	
		$adj = ((cos(deg2rad($angle))) * ($strlen/2));
		$opp = ((sin(deg2rad($angle))) * ($strlen/2));
		$wx = ($mPDF1->w) - $adj + $offset/3;
		$wy = ($mPDF1->h/1.1) + $opp;
		$mPDF1->Rotate($angle,$wx,$wy);
		$mPDF1->Text($wx,$wy,$testo);
		$mPDF1->Rotate(0);
	}
	/* Fine Routine */
	
	
	
	$mPDF1->Output();

  }
  
  public function actionPrintpdfpreventivo($id) {
	$model=Ordini::model()->findByPk($id);  
	if(empty($model->codcliente)) {
		$model->relcliente = new Clienti;
	}
	$htm =$this->renderPartial('printordinepreventivo', array('model'=>$model), true);
	$footer = $this->renderPartial('footerstampapreventivo', array('model'=>$model), true);
	$stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/stampaconsegna.css');
	
	$mPDF1 = Yii::app()->ePdf->mpdf('utf-8','A4', 0, '', 8, 8, 4, 4, 0, 0);
	$mPDF1->SetHTMLFooter($footer);
	$mPDF1->WriteHTML($stylesheet, 1);
	$mPDF1->WriteHTML($htm,2);
	
	/* Routine per mettere watermark a sx "Compilato da" */
			if($model->utente_id != 0) {
				$angle = 90;
				$szfont = 8;
				$testo = 'Compilato da '.Utenti::renderNameById($model->utente_id);
				$strlen = strlen($testo);
				$offset = -16;
				$mPDF1->SetFont( 'sans-serif', "", $szfont-0.1, true, true);	
				$adj = ((cos(deg2rad($angle))) * ($strlen/2));
				$opp = ((sin(deg2rad($angle))) * ($strlen/2));
				$wx = ($mPDF1->w) - $adj + $offset/3;
				$wy = ($mPDF1->h/1.1) + $opp;
				$mPDF1->Rotate($angle,$wx,$wy);
				$mPDF1->Text($wx,$wy,$testo);
				$mPDF1->Rotate(0);
			}
	/* Fine Routine */
	
	
	
	
	$mPDF1->Output();
  }
  	
	
  public function actionPrintetichettapdf($id) { //Andrea
  
	$model=Ordini::model()->findByPk($id);  
	if(empty($model->codcliente)) {
		$model->relcliente = new Clienti;
	}

	$htm =$this->renderPartial('printordineetichette', array('model'=>$model), true);
	$footer = $this->renderPartial('footerstampaetichette', array('model'=>$model), true);
	$stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/stampaconsegna.css');
	
	$mPDF1 = Yii::app()->ePdf->mpdf('','A5-L');
	$mPDF1->SetHTMLFooter($footer);
	$mPDF1->WriteHTML($stylesheet, 1);
	$mPDF1->WriteHTML($htm,2);
	$mPDF1->Output();

  }
  		
	public function actionChangestatusfine($id) {
	
		$model = $this->loadModel($id);
		$model->stato='Consegnato';
		
		if($model->save()) { 
			echo 'OK-Salvato';    
		} else {
			echo 'Errore. Riprovare';
			print_r($model->getErrors());
		} 		
	}
	
	
	public function actionfetchlavori($id) { // Andrea 28/12/2014 interrogo i lavori di un ordine e, via json o html, alimento una tabella in lettura
		$miohtml = '';
		$trovato = 0;
		$lavori = Lavori::model()->findAll('idordine =:id',array(':id'=> $id)); 
		$miohtml = '<table id="tabLavori" cellpadding="2" cellspacing="0" width="100%">';
		$miohtml .= '<tr style="background-color:#eeeeee;">';
		$miohtml .= '<td>&nbsp;</td>';
		$miohtml .= '<td><b>cod</b></td>';
		$miohtml .= '<td><b>descrizione</b></td>';
		$miohtml .= '<td><b>unit&agrave;</b></td>';
		$miohtml .= '<td><b>qt&agrave;</b></td>';
		$miohtml .= '<td><b>prezzo</b></td>';
		$miohtml .= '<td><b>sconto</b></td>';
		$miohtml .= '<td><b>totale</b></td>';
		$miohtml .= '<td><b>reparto</b></td>';
		$miohtml .= '<td><b>tipologia</b></td>';
		
		$miohtml .= '<td><b>stato</b></td>';
		$miohtml .= '<td align="center"><b>stampa</b></td>';
		$miohtml .= '</tr>';
		
		foreach($lavori as $lavoro) {
			
		   $trovato = 1;
		   $miohtml .= '<tr class="singolilavori">';
		   $miohtml .= "<td><a class='plus' title='Aggiorna Lavoro' href='".Yii::app()->createUrl("lavori/loadjsonmodel", array('id'=>$lavoro->id))."' onclick='js:eventButtonUpdate(this.href); return false;'><img src='/produzionesigem/images/plus.png' alt='Aggiorna Lavoro'></a></td>";
		   $miohtml .= "<td>".$lavoro->cod."</td>";
		   $miohtml .= "<td>".substr($lavoro->descrizione,0,80)."</td>";
		   $miohtml .= "<td>".$lavoro->unita."</td>";
		   $miohtml .= "<td style='text-align:right;'>".$lavoro->quantita."</td>";
		   $miohtml .= "<td align='right'>".$lavoro->prezzounitario." &euro;</td>";
   		   $miohtml .= "<td align='center'>".$lavoro->sconto."</td>";
		   $miohtml .= '<td align="right"><b>'.number_format((float)($lavoro->quantita*$lavoro->prezzounitario - ($lavoro->quantita*$lavoro->prezzounitario*$lavoro->sconto/100)),2,'.','').' &euro;</b></td>';		   
		   if($lavoro->grafica == '1') {
			   $miohtml .= "<td>Grafica</td>";
		   } else if($lavoro->montaggio == '1') {
			   $miohtml .= "<td>Montaggio</td>";
		   } else if($lavoro->stampa == '1') {
			   $miohtml .= "<td>Stampa</td>";
		   } else if($lavoro->confezione == '1') {
			   $miohtml .= "<td>Confezione</td>";
		   } else { $miohtml .= "<td>&nbsp;</td>"; }
		   $miohtml .= "<td>".$lavoro->tipologialavoro."</td>";
		   $miohtml .= "<td>".$lavoro->stato."</td>";
		   $miohtml .= "<td align='center'><a href='".Yii::app()->createUrl('lavori/printetichettapdf',array('id'=>$lavoro->idlavoro))."' target='_blank'><img src='".Yii::app()->request->baseUrl.'/images/stampa.png'."' border='0' /></a></td>";
		   $miohtml .= '</tr>';
		   
		}
		$miohtml = $miohtml . '</table>';
		if ($trovato == 1) {
			echo $miohtml;
		} else {
			echo '';
		}
		
	} 
  
  
  
  public function actionfetchlavoriForAutocomplete($id) { // Mose 03/02/2015 interrogo i lavori di un ordine e, via json o html, alimento una tabella in lettura
		$miohtml = '';
		$trovato = 0;
		$lavori = Lavori::model()->findAll('idordine =:id',array(':id'=> $id)); 
		$miohtml = '<table id="tabLavori" cellpadding="2" cellspacing="0" border="0"><tr><td><b>Lavoro</b></td><td><b>Qt&agrave;</b></td><td><b>Prezzo</b></td><td>&nbsp;</td></tr>';
		foreach($lavori as $lavoro) {
			$trovato = 1;
		   $miohtml = $miohtml . "<tr><td>".substr($lavoro->descrizione,0,80)."</td><td style='text-align:right;'>$lavoro->quantita</td><td>$lavoro->prezzounitario</td><td><a href='#' class='addorder' id='".$lavoro->idlavoro."'><img src='images/icon-share.png' border='0' width='20' /></a></td></tr>";
		}
		$miohtml = $miohtml . '</table>';
		if ($trovato == 1) {
			echo $miohtml;
		} else {
			echo '';
		}
		
	} 
  
  
  public function actionLoadlavoroJson($id) {
  
      $model = Lavori::model()->findByPk($id);
       
      
      header('Content-type: application/json');
      echo CJSON::encode($model);
      
      
      
  
  }
  
  
  
  
	
	
  public function actionchangestatuspreventivato($id) { //Andrea 22/11/2014 - cambio lo stato da 'da preventivare' a 'preventivato'
	if ($id!=0) {
		$model = $this->loadModel($id);
		$model->stato='Attesa';
		$model->dapreventivare = 0;
		if($model->save()) { 
			echo 'OK-Salvato';    
		} else {
			echo 'Errore. Riprovare';
		} 		
	} else {
		echo "Errore- Impossibile recuperare l'ordine da salvare ";
	}

  }	
  
  
  public function actionclonaordine($id) { // Andrea 10/11/2014 - clono l'ordine contrassegnandolo come archiviato

	if ($id!=0) {

		$model = $this->loadModel($id);	
		$model->id = null;
		$model->isNewRecord = true;
		$model->archivio = 0;
		$model->stato = 'Inserito'; //lo stato torna ad essere inserito
		$model->save();
		$nuovoID = $model->getPrimaryKey();
		$model->idordine = $nuovoID;
		$model->save();		

		
		$model = $this->loadModel($id);
		$model->archivio = 1;
		$model->idordine = $nuovoID;
		$model->save();
		$vecchioID = $model->getPrimaryKey();		
		
			
		$lavori = Lavori::model()->findAll('idordine =:id',array(':id'=> $vecchioID)); 
		echo "\r\n vecchioid, nuovoid:  $vecchioID, $nuovoID ";
		
		foreach($lavori as $lavoro) {
	
        $connection=Yii::app()->db;
        $command=$connection->createCommand("SELECT MAX(idlavoro) FROM `lavori`");
        $nuovoIdlavoro = $command->queryScalar() + 1;
	
		   $clone = new Lavori();
		   $clone->isNewRecord = true;
		   $clone->id = $nuovoIdlavoro;
		   $clone->idlavoro = $nuovoIdlavoro;
		   $clone->idordine = $nuovoID;
//
		   $clone->cod = $lavoro->cod;
		   $clone->descrizione = $lavoro->descrizione;
		   $clone->quantita = $lavoro->quantita;
		   $clone->unita = $lavoro->unita;
		   $clone->prezzounitario = $lavoro->prezzounitario;
		   $clone->grafica = $lavoro->grafica;
		   $clone->grafstato = $lavoro->grafstato;
		   $clone->grafdove = $lavoro->grafdove;
		   $clone->grafrientro = $lavoro->grafrientro;
		   $clone->grafgrafico = $lavoro->grafgrafico;
		   $clone->grafore = $lavoro->grafore;
		   $clone->grafnote = $lavoro->grafnote;
		   $clone->grafinvio = $lavoro->grafinvio;
		   $clone->montaggio = $lavoro->montaggio;		   
		   $clone->monstato = $lavoro->monstato;
		   $clone->mondove = $lavoro->mondove;
		   $clone->monrientro = $lavoro->monrientro;
		   $clone->monlastre = $lavoro->monlastre;			   
		   $clone->monore = $lavoro->monore;
		   $clone->MonNote = $lavoro->MonNote;
		   $clone->moninvio = $lavoro->moninvio;			   
		   $clone->stampa = $lavoro->stampa;
		   $clone->stamstato = $lavoro->stamstato;
		   $clone->stamdove = $lavoro->stamdove;			   
		   $clone->stamrientro = $lavoro->stamrientro;
		   $clone->stammacchina = $lavoro->stammacchina;
		   $clone->stamtecnico = $lavoro->stamtecnico;		
		   $clone->stamore = $lavoro->stamore;
		   $clone->stamnote = $lavoro->stamnote;
		   $clone->staminvio = $lavoro->staminvio;	
		   $clone->confezione = $lavoro->confezione;
		   $clone->confstato = $lavoro->confstato;
		   $clone->confdove = $lavoro->confdove;		
		   $clone->confrientro = $lavoro->confrientro;
		   $clone->confore = $lavoro->confore;
		   $clone->confnote = $lavoro->confnote;				   
		   $clone->confinvio = $lavoro->confinvio;
		   $clone->stato = $lavoro->stato;
		   $clone->tipologialavoro = $lavoro->tipologialavoro;	
		   $clone->sconto = $lavoro->sconto;
		   $clone->idmontaggio = $lavoro->idmontaggio;
		   $clone->save(); 

			echo "\r\n vecchio idlavoro, nuovoidlavoro $lavoro->idlavoro , $clone->idlavoro ";
			
		}
		echo "fine";	
		exit;
		
	} else {
		echo "Errore- Impossibile archiviare l'ordine ";	
	}
	
	
  }  
  
  
  public function actionClonaordinetest() {
	  if(isset($_GET['id']) && !empty($_GET['id'])) {
		$modelnew = new Ordini();
		$modelold = Ordini::model()->find('id=:ID',array(':ID'=>$_GET['id']));
		$modelnew->attributes=$modelold->attributes;
		$modelnew->id = null;
		$modelnew->idordine = null;
		
		$modelnew->stato = 'Inserito';
		$modelnew->archivio = 0;
		$modelnew->esportato = 0; 
		$modelnew->consegnatassativa = 0; 
		$modelnew->dapreventivare = 0;
		$modelnew->datainserimento = date('Y-m-d').' 00:00:00';
		$modelnew->dataconsegna = date('Y-m-d').' 00:00:00';
		
		
		
		if($modelnew->save()) {
			$modelnew->idordine = $modelnew->id;
			if($modelnew->save()) {
		
				$lavori = Lavori::model()->findAll('idordine =:id',array(':id'=> $modelold->id)); 
		
				foreach($lavori as $lavoro) {
	
					$connection=Yii::app()->db;
					$command=$connection->createCommand("SELECT MAX(idlavoro) FROM `lavori`");
					$nuovoIdlavoro = $command->queryScalar() + 1;
	
					$clone = new Lavori();
					$clone->isNewRecord = true;
					$clone->id = $nuovoIdlavoro;
					$clone->idlavoro = $nuovoIdlavoro;
					$clone->idordine = $modelnew->id;

					$clone->cod = $lavoro->cod;
					$clone->descrizione = $lavoro->descrizione;
				    $clone->quantita = $lavoro->quantita;
					$clone->unita = $lavoro->unita;
					$clone->prezzounitario = $lavoro->prezzounitario;
					$clone->grafica = 0;
					$clone->grafstato = '';
					$clone->grafdove = 0;
					$clone->grafrientro = null;
					$clone->grafgrafico = 0;
					$clone->grafore = 0;
					$clone->grafnote = '';
					$clone->grafinvio = null;
					$clone->montaggio = 0;		   
					$clone->monstato = null;
					$clone->mondove = 0;
					$clone->monrientro = null;
					$clone->monlastre = null;			   
					$clone->monore = 0;
					$clone->MonNote = '';
					$clone->moninvio = null;			   
					$clone->stampa = 0;
					$clone->stamstato = null;
					$clone->stamdove = 0;			   
					$clone->stamrientro = null;
					$clone->stammacchina = null;
					$clone->stamtecnico = null;		
					$clone->stamore = null;
					$clone->stamnote = '';
					$clone->staminvio = null;	
					$clone->confezione = 0;
					$clone->confstato = null;
					$clone->confdove = null;		
					$clone->confrientro = null;
					$clone->confore = null;
					$clone->confnote = '';				   
					$clone->confinvio = null;
					$clone->stato = null;
					$clone->tipologialavoro = $lavoro->tipologialavoro;	
					$clone->sconto = $lavoro->sconto;
					$clone->idmontaggio = $lavoro->idmontaggio;
					$clone->save(); 

				}
				echo "fine";	
				exit;
		
				} else {
					echo "Errore- Impossibile archiviare l'ordine ";	
				}
				
			}
			
		} else {
			echo 'error';
		}
		
	} 
  
  
  public function actionExportordine($id) {

       $modelordine = $this->loadModel($id);
       $criteria = new CDbCriteria();
       $criteria->condition = 'idordine=:idordine';
       $criteria->params = array(':idordine'=>$id);
       $alllavori = Lavori::model()->findAll($criteria);
       $exportTxt = '';
       foreach($alllavori as $singlelavoro) {
		   
		   $tipospedizione = '';
		   $tipospedizione = Yii::app()->db->createCommand('select * from tipispedizione where Tipo=:tipo')->bindValue('tipo',$modelordine->relcliente->tipoconsegna)->queryRow();
		   if(!$tipospedizione) {
			   $tipospedizione = '';
		   }
		   
		  
		   
		   
            $exportTxt .= $modelordine->relcliente->piva.'}'.
                          $modelordine->relcliente->codfiscale.'}'.
                          $modelordine->relcliente->nomeditta.'}'.
                          $modelordine->relcliente->indirizzo.'}'.
                          $modelordine->relcliente->cap.'}'.
                          $modelordine->relcliente->citta.'}'.
                          $modelordine->relcliente->provincia.'}'.
                          $modelordine->relcliente->referente.'}'.
                          $modelordine->relcliente->telefono.'}'.
                          $modelordine->relcliente->fax.'}'.
                          $modelordine->relcliente->emai.'}'.
                          $modelordine->relcliente->pagamento.'}'.
						  $modelordine->relcliente->abi.'}'.
						  $modelordine->relcliente->banca.'}'.
						  $modelordine->relcliente->cab.'}'.
						  $modelordine->relcliente->agenzia.'}'.	
                          $tipospedizione.'}'. 
						  $modelordine->agente.'}'.
						  $singlelavoro->cod.'}'.
                          $singlelavoro->descrizione.'}'.
                          $singlelavoro->unita.'}'.
                          $singlelavoro->quantita.'}'.
                          number_format($singlelavoro->prezzounitario, 4, ',', '').'}'.
						  $singlelavoro->sconto.'}'.
                          $modelordine->costotrasporto.'}'.
                          "\r\n";
       }
       
       
       $modelordine->esportato = '1';
       $modelordine->save();
	   
	   
	   $myfile = fopen("c:/esportazione/export".$modelordine->idordine.".txt", "w");
	   
	   fwrite($myfile, $exportTxt);
	   fclose($myfile);
	   //passthru("net use w: \\192.168.0.100\pippo");
	   //$myfile = fopen('Z:\ciao.txt', "a");

     //$myfile = fopen("w:/sigemexporter/export".$modelordine->idordine.".txt", "w");
		/*if(!copy("c:/esportazione/export52636.txt",'\\192.168.0.100\pippo\export52636.txt'))
		{
			print_r(error_get_last());
			//echo "COPY ERROR: ".$errors['type'];
			//echo "<br />\n".$errors['message'];
		} else {
			echo "File copied from remote!";
		}*/

			   
	   
	   
	
	   echo 'ok';
  
  }
  
  public function actionSetStatoProntoAll($id) {
	  
	$criteria = new CDbCriteria();
    $criteria->condition = 'idordine=:idordine';
    $criteria->params = array(':idordine'=>$id);
    $alllavori = Lavori::model()->findAll($criteria);
    
    foreach($alllavori as $singlelavoro) {
	  

      $singlelavoro->grafica = '0';
	  $singlelavoro->montaggio = '0';
	  $singlelavoro->stampa = '0';
	  $singlelavoro->confezione = '0';
	  $singlelavoro->stato='Pronto';
      
      if($singlelavoro->save()) { 
            echo 'Stato impostato<br />';    
      } else {
            echo 'Errore';
      } 
	}
	
	$modelordine = $this->loadModel($id);
	$modelordine->stato = 'Pronto';
	$modelordine->save();
	
}
  
  
	public function actionDeleteAll() {
		
		if(isset($_POST['theIds']) && count($_POST['theIds'])) {
			$arr = explode(',', $_POST['theIds']);
			$criteria = new CDbCriteria;
			$criteria->addInCondition('id' ,$arr );
			if(Ordini::model()->deleteAll($criteria) > 0) {
				$criteria = new CDbCriteria;
				$criteria->addInCondition('idordine' ,$arr);
				Lavori::model()->deleteAll($criteria);
			}
		}
	}  
	
	
	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Ordini the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Ordini::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Ordini $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='ordini-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
	
	private function data_it_to_eng($var){
		list($gg, $mm, $aaaa) = explode("-", $var);
		return $aaaa."-".$mm."-".$gg;
	}
}
