<?php

/**
 * This is the model class for table "lavori".
 *
 * The followings are the available columns in table 'lavori':
 * @property integer $id
 * @property integer $idlavoro
 * @property integer $idordine
 * @property string $cod
 * @property string $descrizione
 * @property integer $quantita
 * @property string $unita
 * @property double $prezzounitario
 * @property integer $grafica
 * @property string $grafstato
 * @property integer $grafdove
 * @property string $grafrientro
 * @property integer $grafgrafico
 * @property double $grafore
 * @property string $grafnote
 * @property string $grafinvio
 * @property integer $montaggio
 * @property string $monstato
 * @property integer $mondove
 * @property string $monrientro
 * @property string $monlastre
 * @property double $monore
 * @property string $MonNote
 * @property string $moninvio
 * @property integer $stampa
 * @property string $stamstato
 * @property integer $stamdove
 * @property string $stamrientro
 * @property integer $stammacchina
 * @property integer $stamtecnico
 * @property double $stamore
 * @property string $stamnote
 * @property string $staminvio
 * @property integer $confezione
 * @property string $confstato
 * @property integer $confdove
 * @property string $confrientro
 * @property double $confore
 * @property string $confnote
 * @property string $confinvio
 * @property string $stato
 * @property string $tipologialavoro
 * @property double $sconto
 * @property integer $idmontaggio
 */
class Lavori extends CActiveRecord
{
  public $totale;
  public $totaleconiva;
  public $reparto;
  public $sommaprezzi; 
  public $plus = false;
  public $nosospesi;
  public $searchorderby;
  public $idsordini = array();
  public $relidcliente = '';
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'lavori';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		return array(
			array('idlavoro', 'required'),
			array('id, idlavoro, idordine, quantita, grafica, grafdove, grafgrafico, montaggio, mondove, stampa, stamdove, stammacchina, stamtecnico, confezione, confdove, idmontaggio', 'numerical', 'integerOnly'=>true),
			array('prezzounitario, grafore, monore, stamore, confore, sconto, totale,sommaprezzi', 'numerical'),
			array('plus','boolean'),
			array('cod, unita, grafstato, monstato, monlastre, stamstato, confstato, stato, reparto', 'length', 'max'=>50),
			array('grafnote, MonNote, stamnote, confnote', 'length', 'max'=>255),
			array('descrizione','length','max'=>500),
			array('tipologialavoro', 'length', 'max'=>128),
			array('grafrientro, grafinvio, monrientro, moninvio, stamrientro, staminvio, confrientro, confinvio', 'safe'),
			array('id, idlavoro, idordine, cod, descrizione, quantita, unita, prezzounitario, grafica, grafstato, grafdove, grafrientro, grafgrafico, grafore, grafnote, grafinvio, montaggio, monstato, mondove, monrientro, monlastre, monore, MonNote, moninvio, stampa, stamstato, stamdove, stamrientro, stammacchina, stamtecnico, stamore, stamnote, staminvio, confezione, confstato, confdove, confrientro, confore, confnote, confinvio, stato, tipologialavoro, sconto, idmontaggio', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return array(
			'relordine'=>array(self::HAS_ONE,'Ordini', array('idordine'=>'idordine')),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'idlavoro' => 'Idlavoro',
			'idordine' => 'Idordine',
			'cod' => 'Cod',
			'descrizione' => 'Descrizione',
			'quantita' => 'Q.ta',
			'unita' => 'Unita',
			'prezzounitario' => 'Prezzo',
			'grafica' => 'Settore Grafico',
			'grafstato' => 'Stato',
			'grafdove' => 'Dove',
			'grafrientro' => 'Rientro',
			'grafgrafico' => 'Grafico',
			'grafore' => 'N.Ore',
			'grafnote' => 'Note',
			'grafinvio' => 'Invio',
			'montaggio' => 'Montaggio',
			'monstato' => 'Stato',
			'mondove' => 'Dove',
			'monrientro' => 'Rientro',
			'monlastre' => 'ID Montaggio',
			'monore' => 'N.Ore',
			'MonNote' => 'Mon Note',
			'moninvio' => 'Invio',
			'stampa' => 'Stampa',
			'stamstato' => 'Stato',
			'stamdove' => 'Dove',
			'stamrientro' => 'Rientro',
			'stammacchina' => 'Macchina',
			'stamtecnico' => 'Tecnico',
			'stamore' => 'Ore',
			'stamnote' => 'Note',
			'staminvio' => 'Invio',
			'confezione' => 'Confezione',
			'confstato' => 'Stato',
			'confdove' => 'Dove',
			'confrientro' => 'Rientro',
			'confore' => 'Ore',
			'confnote' => 'Note',
			'confinvio' => 'Invio',
			'stato' => 'Stato',
			'tipologialavoro' => 'Tipologialavoro',
			'sconto' => 'Sconto %',
			'idmontaggio' => 'Idmontaggio',
      'totale'=>'Totale',
      'voidlabel'=>'',
      'nosospesi' => 'Escludi Sospesi',
		);
	}


  public function getTotale() {
      return $this->sommaprezzi;
  
  }
  
  

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('idlavoro',$this->idlavoro);
		$criteria->compare('idordine',$this->idordine);
		$criteria->compare('cod',$this->cod,true);
		$criteria->compare('descrizione',$this->descrizione,true);
		$criteria->compare('quantita',$this->quantita);
		$criteria->compare('unita',$this->unita,true);
		$criteria->compare('prezzounitario',$this->prezzounitario);
		$criteria->compare('grafica',$this->grafica);
		$criteria->compare('grafstato',$this->grafstato,true);
		$criteria->compare('grafdove',$this->grafdove);
		$criteria->compare('grafrientro',$this->grafrientro,true);
		$criteria->compare('grafgrafico',$this->grafgrafico);
		$criteria->compare('grafore',$this->grafore);
		$criteria->compare('grafnote',$this->grafnote,true);
		$criteria->compare('grafinvio',$this->grafinvio,true);
		$criteria->compare('montaggio',$this->montaggio);
		$criteria->compare('monstato',$this->monstato,true);
		$criteria->compare('mondove',$this->mondove);
		$criteria->compare('monrientro',$this->monrientro,true);
		$criteria->compare('monlastre',$this->monlastre,true);
		$criteria->compare('monore',$this->monore);
		$criteria->compare('MonNote',$this->MonNote,true);
		$criteria->compare('moninvio',$this->moninvio,true);
		$criteria->compare('stampa',$this->stampa);
		$criteria->compare('stamstato',$this->stamstato,true);
		$criteria->compare('stamdove',$this->stamdove);
		$criteria->compare('stamrientro',$this->stamrientro,true);
		$criteria->compare('stammacchina',$this->stammacchina);
		$criteria->compare('stamtecnico',$this->stamtecnico);
		$criteria->compare('stamore',$this->stamore);
		$criteria->compare('stamnote',$this->stamnote,true);
		$criteria->compare('staminvio',$this->staminvio,true);
		$criteria->compare('confezione',$this->confezione);
		$criteria->compare('confstato',$this->confstato,true);
		$criteria->compare('confdove',$this->confdove);
		$criteria->compare('confrientro',$this->confrientro,true);
		$criteria->compare('confore',$this->confore);
		$criteria->compare('confnote',$this->confnote,true);
		$criteria->compare('confinvio',$this->confinvio,true);
		$criteria->compare('stato',$this->stato,true);
		$criteria->compare('tipologialavoro',$this->tipologialavoro,true);
		$criteria->compare('sconto',$this->sconto);
		$criteria->compare('idmontaggio',$this->idmontaggio);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
	
	
	public function searchLavoripopup($idcliente) {
	
				$criteria=new CDbCriteria;
				//$criteria->addInCondition('t.idordine', $this->idsordini);
				$criteria->addCondition('relordine.codcliente = "'.$idcliente.'"');
				$criteria->compare('t.cod',$this->cod,true);
				$criteria->compare('t.quantita',$this->quantita,true);
				$criteria->compare('t.unita',$this->unita,true);
				$criteria->compare('t.descrizione',$this->descrizione,true);
				$criteria->compare('t.unita',$this->unita,true);
				$criteria->compare('t.prezzounitario',$this->prezzounitario,true);
				$criteria->order = 'relordine.datainserimento DESC';
				$criteria->with = 'relordine';
				
				
 				return new CActiveDataProvider('Lavori', array('pagination'=>false,'criteria'=>$criteria,));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Lavori the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
